# Visual Studio Code

Очень популярный редактор для разработчиков. Достаточно простой с кучей дополнительных расширений которые можно установить из маркета. 

В отличие от Eclipse быстрый, минималистичный и намного проще в настройке.

<p align="center"> <img src="images/vscode_demo.gif"></p>
<p align="center"> <img src="images/vscode_graph_demo.gif"></p>
<p align="center"> <img src="images/vscode_ssh_demo.gif"></p>
<p align="center"> <img src="images/vscode_wsl_demo.gif"></p>

Основные достоинства:
- Минималистичный
- Кроссплатформенный
- Отладка по SSH и в WSL
- Простой в настройке
- Встроенный Git
- Терминал
- поддерживает SWO и SEGGER RTT

## Установка

На [официальном сайте](https://code.visualstudio.com/Download) можно скачать различные версии для установки.

- User (только для одного пользователя)
- System (если пользователь Администратор)

Если при запуске инсталятора выскакивает похожее окно, то вы пытаетесь установить не ту версию.
<p align="center"> <img src="images/vscode1.png"></p>

Функционал VS Code можно значительно расширить используя дополнительные расширения из маркета.

Для нашего случая устанавливаем следующее:
- [C/C++](https://marketplace.visualstudio.com/items?itemName=ms-vscode.cpptools)
- [Better C++ Syntax](https://marketplace.visualstudio.com/items?itemName=jeff-hykin.better-cpp-syntax)
- [Git Graph](https://marketplace.visualstudio.com/items?itemName=mhutchie.git-graph)
- [Remote - SSH](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-ssh)
- [Remote - SSH: Editing Configuration Files](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-ssh-edit)
- [Remote - WSL](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-wsl)
- [Cortex-Debug](https://marketplace.visualstudio.com/items?itemName=marus25.cortex-debug) - поддержка отладки с различными программаторами
- [stm32-for-vscode](https://marketplace.visualstudio.com/items?itemName=bmd.stm32-for-vscode) - надстройка над Cotex-Debug для автоматизации установки Toolchain и корневого Make-файла

## Настройка
Чтобы открыть настройки нажимаем Ctrl+,

Полезные настройки:
- Files: Auto save - автоматическое сохранение файлов
- Window: Title - настройка заголовка окна. Удобно установить в `${rootName}${separator}${rootPath}`
- Editor: Render Whitespace - показать невидимые символы. Полезно для мейкфайлов.

## VS Code uninstall

Если нужно полностью удалить VS Code, то кроме обычного удаления через Uninstall, нужно также почистить следующие папки:
- `C:\Program Files\Microsoft VS Code`
- `%USERPROFILE%\.vscode`
- `%AppData%\Code`





